//
//  WKWebViewController.swift
//  test sizes
//
//  Created by John van Gellecum on 29/03/2020.
//  Copyright © 2020 John van Gellecum. All rights reserved.
//

import UIKit
import WebKit
import AVFoundation

class WKWebViewController: UIViewController, WKNavigationDelegate  ,WKScriptMessageHandler {
 
    
    //-- declare a WKWebView
    var webView: WKWebView!
    
    //-- declare a any vars
    var hello :String = ""
    
    //-- declare a message name to use later
    let messageName = "openStore"
    
    //-- declare a your html file  name to use later ( do not include the .html )
    let htmlName = "Default"
    
    
    
    
    
      // MARK: - WKUserContentController:  -> webkit Posted messages handler delegate //-- handles messages from hype page
    func userContentController(_ userContentController: WKUserContentController, didReceive message: WKScriptMessage) {
        
        

          if message.name ==  "openStore" {
          print("\(message.body )")
          //-- Get the message passed to app
        _   =  message.body as! String
          
        //https://apps.apple.com/us/app/guitar-colour-chords/id1398192963?l=nl&ls=1
                      
             // anURL  = URL.init(string: message.body as! String)!
              guard let url = URL(string: "\(message.body)") else {
                  return //be safe
              }
              
              if #available(iOS 10.0, *) {
                  UIApplication.shared.open(url, options: [:], completionHandler: nil)
              } else {
                  UIApplication.shared.openURL(url)
              }
            
          }
        
        /*
        
        
        //-- Posted messages  from Hype page
        if message.name ==  messageName {
            
            //-- Get the message passed to app
            hello   =  message.body as! String
            
            
            //-- Speak name
            let utterance = AVSpeechUtterance(string:"Hello \( hello)")
            utterance.voice = AVSpeechSynthesisVoice(language: "en-US")
            
            let synth = AVSpeechSynthesizer()
            synth.speak(utterance)
            
        }
        */
        
        
    }
    
    
    
    override func viewDidLoad() {
        
        super.viewDidLoad()

        
        //-- configure the WKWebView
        
        //-- init config and controller
        let wconfiguration = WKWebViewConfiguration()
        let wcontroller = WKUserContentController()
        
//MARK: WKUserContentController Init :  We must add the webkit scripts Posted messages we expect to get from the Hype Page to the controller
        wcontroller.add(self, name:  messageName )
        
        //-- attach controller, config to WKWebview
        wconfiguration.userContentController = wcontroller;
        
 
        wconfiguration.allowsInlineMediaPlayback = true
        wconfiguration.mediaTypesRequiringUserActionForPlayback = []
 
        
        webView =  WKWebView(frame: .zero, configuration: wconfiguration)
        

        let  theFileName = (htmlName as NSString).lastPathComponent
        let htmlPath = Bundle.main.path(forResource: theFileName, ofType: "html")
        
        let folderPath = Bundle.main.bundlePath
        
        let baseUrl = URL(fileURLWithPath: folderPath, isDirectory: true)
        
        do {
            
            let htmlString = try NSString(contentsOfFile: htmlPath!, encoding: String.Encoding.utf8.rawValue)
            
            webView.loadHTMLString(htmlString as String, baseURL: baseUrl)
            
        } catch {
            
            // catch error
            
        }
        
        
        webView.navigationDelegate = self
      
        webView.scrollView.bounces = false
        webView.scrollView.isScrollEnabled = false
        webView.isOpaque = false
        webView.isHidden = false
 
        view = webView
        
    }
    
    
    // MARK: Action for the App to send message to Hype
//    @objc func selectorX(_ sender: UIBarButtonItem) {
//
//        webView!.evaluateJavaScript("HYPE.documents['\(htmlName)'].showSceneNamed('\(sender.title!)', HYPE.documents['\(htmlName)'].kSceneTransitionCrossfade, 0.2);", completionHandler:nil )
//
//        sender.title = ( sender.title  == "Scene 2" ? "Scene 1" : "Scene 2")
//
//
//    }
    
    // MARK: Add navigationBar and buttons programmatically
 //   override func viewWillLayoutSubviews() {
        
      //  _ = UIApplication.shared.statusBarFrame.size.height;
        
     //   let window = UIApplication.shared.windows.filter {$0.isKeyWindow}.first
    //    _ = window?.windowScene?.statusBarManager?.statusBarFrame.height ?? 0
        /*
        let width = self.view.frame.width
        let navigationBar: UINavigationBar = UINavigationBar(frame: CGRect(x: 0, y: startingYPos, width: width, height: 44))
        self.view.addSubview(navigationBar);
        let navigationItem = UINavigationItem(title: "Navigation bar")
        let doneBtn = UIBarButtonItem(title: "Scene 2", style: UIBarButtonItem.Style.plain, target: nil, action: #selector(selectorX))
        
        navigationItem.rightBarButtonItem = doneBtn
        navigationBar.setItems([navigationItem], animated: false)
        
        */
    }
    
    
    
    
//}

